/* ========================================================================== *
!*
!* SAMPLE SOURCE CODE - SUBJECT TO THE TERMS OF SAMPLE CODE LICENSE AGREEMENT,
!* http://software.intel.com/en-us/articles/
!*        intel-sample-source-code-license-agreement/
!*
!* Copyright 2010-2014 Intel Corporation
!*
!* THIS FILE IS PROVIDED "AS IS" WITH NO WARRANTIES, EXPRESS OR IMPLIED,
!* INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTY OF MERCHANTABILITY,
!* FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT OF INTELLECTUAL
!* PROPERTY RIGHTS.
!*
!* ========================================================================== */
#include "multiply.h"

void matvec(unsigned int rows, unsigned int cols,
            FTYPE a[][cols],
            FTYPE b[rows],
            FTYPE x[cols])
{
    int i, j;
    enum { inc_i = 1, inc_j = 1 };

    __assume_aligned(a, 64);
    __assume_aligned(b, 64);
    __assume_aligned(x, 64);

    for (i = 0; i < rows; i += inc_i) {
#pragma ivdep
#pragma vector aligned
        b[i] += __sec_reduce_add(a[i][0:cols:inc_j] * x[0:cols:inc_j]);
    }
}
